(* GNU-GPL
 * System Compression - Plugin de compression au format Huffman
 * Copyright (c) 2002 Ulrich Van Den Hekke (ulrich.vdh@free.fr)
 * 24 rue Jean Jaures
 * 59560 Comines
 *
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
 * les termes de la Licence Publique Gnrale GNU publie par la
 * Free Software Foundation (version 2 ou bien toute autre version ultrieure
 * choisie par vous).
 *
 * Ce programme est distribu car potentiellement utile, mais
 * SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris les garanties de
 * commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 * Licence Publique Gnrale GNU pour plus de dtails.
 *
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
 * temps que ce programme ; si ce n'est pas le cas, crivez  la
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 *
 *)

(******************************************************************************)
(* Plugin de compression au format Huffman                                    *)
(* Version : 1.0.0.0                                                          *)
(* Author : Ulrich Van Den Hekke                                              *)
(* Create day : 06/07/2002                                                    *)
(* -------------------------------------------------------------------------- *)
(* Serial : 3F92D1-0207153B-0DA95B3A                                          *)
(* Object : Compresse les donnes au format Huffman pour le logiciel          *)
(*          "System C"                                                        *)
(******************************************************************************)

library Huffman;

uses
  Windows,
  SysUtils,
  Common in 'Common.pas';

{$E ALG}

{$R *.res}

{$LIBPREFIX 'sys'}

resourcestring
  rsAboutCaption  = 'A propos de ...';
  rsAboutText     = 'Plugin de compression Huffman, Version v%d.%.2d par Ulrich Van Den Hekke';

const
  cstInformations : TInformations
                  = (iName        : 'huffman'#0#0#0#0#0#0#0#0#0;
                     iDescription : 'Plugin de compression au format Huffman'#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;
                     iSerial      : '3F92D1-0207153B-0DA95B3A';
                     iVersion     : 0;
                    );

function Informations: TInformations; stdcall;
begin
  result := cstInformations;
end;

procedure About(hWnd: HWND); stdcall;
begin
  MessageBox(hWnd, PChar(Format(rsAboutText, [1, 0])), PChar(rsAboutCaption), MB_OK or MB_ICONINFORMATION);
end;

procedure Pack(var BytesWritten: Integer; const getProc: TGetByte; const putProc: TPutByte); stdcall;
begin
  putProc(0, true);
  BytesWritten := -1;
end;

procedure Unpack(const TextSize: Integer; const getProc: TGetByte; const putProc: TPutByte); stdcall;
begin
  putProc(0, true);
end;

exports
  Informations,
  About,
  Pack,
  Unpack;

begin
end.
