(* GNU-GPL
 * System Compression - Plugin de compression au format RLE
 * Copyright (c) 2002 Ulrich Van Den Hekke (ulrich.vdh@free.fr)
 * 24 rue Jean Jaures
 * 59560 Comines
 *
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
 * les termes de la Licence Publique Gnrale GNU publie par la
 * Free Software Foundation (version 2 ou bien toute autre version ultrieure
 * choisie par vous).
 *
 * Ce programme est distribu car potentiellement utile, mais
 * SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris les garanties de
 * commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 * Licence Publique Gnrale GNU pour plus de dtails.
 *
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
 * temps que ce programme ; si ce n'est pas le cas, crivez  la
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 *
 *)

(******************************************************************************)
(* Plugin de compression au format RLE                                        *)
(* Version : 1.0.0.0                                                          *)
(* Author : Ulrich Van Den Hekke                                              *)
(* Create day : 06/07/2002                                                    *)
(* -------------------------------------------------------------------------- *)
(* Serial : 503686-02070632-F8BC592F                                          *)
(* Object : Compresse les donnes au format RLE pour le logiciel "System C"   *)
(******************************************************************************)

library RLE;

uses
  Windows,
  SysUtils,
  Common in 'Common.pas';

{$E ALG}

{$R *.res}

{$LIBPREFIX 'sys'}

resourcestring
  rsAboutCaption  = 'A propos de ...';
  rsAboutText     = 'Plugin de compression au format RLE, Version v%d.%.2d par Ulrich Van Den Hekke';

const
  cstInformations : TInformations
                  = (iName        : 'rle'#0#0#0#0#0#0#0#0#0#0#0#0#0;
                     iDescription : 'Plugin de compression au format RLE'#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;
                     iSerial      : '503686-02070632-F8BC592F';
                     iVersion     : 0;
                    );

function Informations: TInformations; stdcall;
begin
  result := cstInformations;
end;

procedure About(hWnd: HWND); stdcall;
begin
  MessageBox(hWnd, PChar(Format(rsAboutText, [1, 0])), PChar(rsAboutCaption), MB_OK or MB_ICONINFORMATION);
end;

procedure Pack(var BytesWritten: Integer; const getProc: TGetByte; const putProc: TPutByte); stdcall;
var data, previous_data: byte;
    nb_occ             : integer;
    continous          : boolean;
begin
  nb_occ := 1;
  continous := getProc(previous_data);
  while(continous) do begin
    continous := getProc(data);
    if((continous) and (data = previous_data)) then begin
      Inc(nb_occ);
      if(nb_occ = 257) then begin
        putProc(previous_data, false);
        putProc(previous_data, false);
        putProc(Byte(nb_occ - 2), false);
        nb_occ := 0;
      end;
    end else begin
      case (nb_occ) of
        0      : ;
        1      : putProc(previous_data, false);
        2      : begin
                   putProc(previous_data, false);
                   putProc(previous_data, false);
                   putProc(0, false);
                 end;
        else     begin
                   putProc(previous_data, false);
                   putProc(previous_data, false);
                   putProc(Byte(nb_occ - 2), false);
                 end;
      end;
      nb_occ := 1;
    end;
    previous_data := data;
  end;
  putProc(0, true);
  BytesWritten := -1;
end;

procedure Unpack(const TextSize: Integer; const getProc: TGetByte; const putProc: TPutByte); stdcall;
var data, previous_data, repet : Byte;
    i                          : integer;
    just_flushed, cont         : boolean;
begin
  just_flushed := false;
  cont := getProc(previous_data);
  while(cont) do begin
    cont := getProc(data);
    if((not just_flushed) and cont and (data = previous_data)) then begin
      cont := getProc(repet);
      for I := 0 to repet + 1 do putProc(data, false);
      just_flushed := true;
    end else begin
      if(not just_flushed) then putProc(previous_data, false);
      just_flushed  := false;
      previous_data := data;
    end;
  end;
  putProc(0, true);
end;

exports
  Informations,
  About,
  Pack,
  Unpack;

begin
end.
